define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {

        index: function () {
            $('.btn-add').data('area',['85%','85%']);
            $('.btn-edit').data('area',['85%','85%']);
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'teacher/practice/index' + location.search,
                    add_url: 'teacher/practice/add',
                    edit_url: 'teacher/practice/edit',
                    del_url: 'teacher/practice/del',
                    multi_url: 'teacher/practice/multi',
                    import_url: 'teacher/practice/import',
                    table: 'teacher_collection',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'exam_collection_id',
                sortName: 'exam_collection_id',
                fixedColumns: true,
                fixedRightNumber: 1,
                searchFormVisible:true,
                columns: [
                    [
                        {checkbox: true},
                        {field: 'exam_collection_id', title: __('编号')},
                        {field: 'exam_collection_name', title: __('Exam_collection_name'), operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                        {field: 'sim_type', title: __('Sim_type'),searchList:{"0001":"FZD04B型侦毒器","0002":"FZB006型毒剂报警器","0003":"防化兵用毒剂报警器"},formatter: Table.api.formatter.simtype},
                        {field: 'question_setting_method', title: __('Question_setting_method'),searchList:{"1":"系统随机","2":"教师自选","3":"任务自选"},formatter: Table.api.formatter.simmethod},
                        {field: 'exam_collection_type', title: __('Exam_collection_type'),operate: false,formatter: function (value, row, index) {
                                return '练习';
                            }
                        },
                        {
                            field: 'exam_collection_state',searchList:{"2":"打开","3":"关闭"},
                            title: __('Exam_collection_state'),
                            align: 'center',
                            table: table,
                            formatter: Table.api.formatter.collectonstate
                        },

                        // {field: 'task_id', title: __('Task_id')},
                        {field: 'limit_duration', title: __('Limit_duration')},
                        {field: 'start_time', title: __('Start_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'end_time', title: __('End_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        // {field: 'create_user_id', title: __('Create_user_id')},
                        {field: 'create_by', title: __('Create_by'), operate: 'LIKE'},
                        {field: 'createtime', title: __('Create_time'),  operate:'RANGE', addclass:'datetimerange', autocomplete:false,formatter: Table.api.formatter.datetime},
                        // {field: 'update_by', title: __('Update_by'), operate: 'LIKE'},
                        // {field: 'update_time', title: __('Update_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        // {field: 'remark', title: __('Remark'), operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate,
                            // formatter: Table.api.formatter.operate
                            formatter: Table.api.formatter.buttons,
                            buttons: [
                                {
                                    name: 'dispatch',
                                    text: '',
                                    icon: 'fa fa-pencil',
                                    title: '编辑',
                                    classname: 'btn btn-success btn-xs btn-magic btn-dialog',
                                    extend: 'data-area=\'["85%","85%"]\'',
                                    url: 'teacher/practice/edit',
                                },
                                // {
                                //     name: 'dispatch',
                                //     text: '',
                                //     icon: 'fa fa-trash',
                                //     title: '删除',
                                //     classname: 'btn btn-danger btn-xs btn-magic btn-ajax',
                                //     url: 'teacher/practice/del',
                                //     confirm: '确定要删除吗？',
                                //     success: function (data, ret) {
                                //         $(".btn-refresh").trigger("click");
                                //     },
                                //     error: function (data, ret) {
                                //         Layer.alert(ret.msg);
                                //         return false;
                                //     }
                                // }
                            ],
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        persent: function () {
            Table.api.init({
                extend: {
                    index_url: 'teacher/practice/persent' + location.search,
                    indexed_url: 'teacher/practice/examing' + location.search,
                    table: 'teacher_exams',
                }
            });

            var table = $("#table");
            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'exam_id',
                sortName: 'exam_id',
                toolbar: '#toolbar',
                fixedColumns: true,
                fixedRightNumber: 1,
                searchFormVisible:false,
                showExport:false,
                search:false,
                columns: [
                    [
                        // {checkbox: true},
                        {field: 'fault_name', title: __('更换件')},
                        {field: 'create_by', title: __('学员姓名')},
                        {field: 'request_status', title: __('状态'),
                            formatter: function(value, row,index) {
                                if(value==1){
                                    return '<span class="text-warning">待处理</span>';
                                }else if(value==2){
                                    return '<span class="text-success">已送</span>';
                                }else if(value==3){
                                    return '<span class="text-danger">已驳回</span>';
                                }
                            }
                        },
                        {field: 'createtime', title: __('申请时间'), formatter: Table.api.formatter.datetime, operate: false, addclass: 'datetimerange', sortable: true},
                        {field: 'operate', title: __('Operate'), table: table,
                            events: Table.api.events.operate,
                            // formatter: Table.api.formatter.operate
                            formatter: Table.api.formatter.buttons,
                            buttons: [
                                {
                                    name: 'dispatch',
                                    text: '',
                                    icon: 'fa fa-check',
                                    title: '已送',
                                    classname: 'btn btn-success btn-xs btn-magic btn-ajax',
                                    url: 'teacher/exams/handle/type/1',
                                    visible: function (rr) {
                                        if(rr.request_status == 1 || rr.request_status == 0){
                                            return true;
                                        }
                                        return  false;
                                    },
                                    success: function (data, ret) {
                                        table.bootstrapTable("refresh");
                                    },
                                },{
                                    name: 'dispatch',
                                    text: '',
                                    icon: 'fa fa-reply-all',
                                    title: '驳回',
                                    classname: 'btn btn-danger btn-xs btn-magic btn-ajax',
                                    url: 'teacher/exams/handle/type/2',
                                    visible: function (rr) {
                                        if(rr.request_status == 1 || rr.request_status == 0){
                                            return true;
                                        }
                                        return  false;
                                    },
                                    success: function (data, ret) {
                                        table.bootstrapTable("refresh");
                                    },
                                }
                            ],
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);



            var table1 = $("#table1");
            // 初始化表格
            table1.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.indexed_url,
                pk: 'exam_collection_id',
                sortName: 'exam_collection_id',
                toolbar: '#toolbar1',
                fixedColumns: true,
                fixedRightNumber: 1,
                searchFormVisible:false,
                columns: [
                    [
                        // {checkbox: true},
                        {field: 'seat_id', title: __('座号')},
                        {field: '', title: __('模拟器状态'),
                            formatter: function(value, row,index) {
                                return '<span class="text-success">就绪</span>';
                            }
                        },
                        {field: 'user_username', title: __('学员学号')},
                        {field: 'user_nickname', title: __('学员姓名')},
                        {field: '', title: __('状态'),
                            formatter: function(value, row,index) {
                                return '<span class="text-success">已交卷</span>';
                            }
                        },
                        {field: 'total_score', title: __('模拟成绩')},
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table1);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                var rel_Ids = [];
                Table.api.init({
                    extend: {
                        index_url: 'department/admin/departadmintotal' + location.search,
                    }
                });
                var table = $("#table1");
                // 初始化表格
                table.bootstrapTable({
                    url: $.fn.bootstrapTable.defaults.extend.index_url,
                    pk: 'id',
                    sortName: 'id',
                    fixedColumns: true,
                    fixedRightNumber: 1,
                    searchFormVisible:false,
                    Search:false,
                    columns: [
                        [
                            {checkbox: true,
                                formatter: function(value,row,index){
                                    // console.log(row.id+'####'+Config.row_info.depart_ids)
                                    if(Config.row_info != undefined && Config.row_info.depart_ids.indexOf(row.id)>-1){
                                        rel_Ids.push(row.id);
                                        return true;
                                    }
                                    return false;
                                }
                            },
                            {field: 'department_name', title: __('区队名称'), operate: false,width: '400px', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                            {field: 'department_admin_count', title: __('全部人员数量'),operate: false},
                        ]
                    ]
                });

                // 为表格绑定事件
                Table.api.bindevent(table);

                table.on('click-row.bs.table', function (e, row, element) {
                    console.log(rel_Ids)
                    // console.log('row')
                    if(!$.inArray(row.id,rel_Ids)){
                        arr = $.grep(rel_Ids, function(value) {
                            return value != row["id"];
                        });
                        rel_Ids = arr;
                    }else if(rel_Ids.indexOf(row.id)>-1){
                        var index = rel_Ids.indexOf(row.id);
                        if (index > -1) {
                            rel_Ids.splice(index, 1);
                        }
                    }else{
                        rel_Ids.push(row.id);
                    }
                    $(".depart_ids").val(rel_Ids.join());
                });

                $(document).on('change', '#c-question_setting_method', function () {
                    if($(this).val()==1){
                        $(".btn-sm,.btn-task").css('display','none');
                    }else if($(this).val()==2){
                        $(".btn-sm").css('display','block');
                        $(".btn-task").css('display','none');
                    }else if($(this).val()==3){
                        $(".btn-sm").css('display','none');
                        $(".btn-task").css('display','block');
                    }
                    $(".question_ids").val(0);
                });
                //考题
                $(document).on('click', '.btn-sm', function () {
                    var simtype = $("#c-sim_type").val();
                    if(!simtype){
                        Layer.alert('请选择模拟器类型');
                        return false
                    }
                    var title = '选择考题';
                    Fast.api.open(Fast.api.fixurl("teacher/collection/faults/type/"+simtype), title, {
                        area: ["85%", "85%"],
                        maxmin: true,
                        moveOut: false,
                        offset: ['40px'],
                        callback: function(value) {
                            console.log(value)
                            if (value.task_id) {
                                $(".question_ids").val(value.task_id);
                            }
                        }
                    });
                });
                //任务
                $(document).on('click', '.btn-task', function () {
                    var simtype = $("#c-sim_type").val();
                    if(!simtype){
                        Layer.alert('请选择模拟器类型');
                        return false;
                    }
                    var title = '选择任务';
                    parent.Fast.api.open(Fast.api.fixurl("teacher/collection/task/type/"+simtype), title, {
                        area: ["85%", "85%"],
                        maxmin: true,
                        moveOut: false,
                        offset: ['40px'],
                        callback: function(value) {
                            if (value.task_id) {
                                $(".question_ids").val(value.task_id);
                            }
                        }
                    });
                });

                // $("input[name='btSelectAll']").click(function () {
                //     var ids = Table.api.selectedids(table);
                //     console.log(ids);
                //     $(".depart_ids").val(ids);
                // });
                $("input[name='btSelectAll']").css('display','none');
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});
